//
// See the file LICENSE for redistribution information.
//
// Copyright (c) 2002,2008 Oracle.  All rights reserved.
//
// $Id: NsReindexer.hpp,v 1.5 2008/01/08 21:54:24 bostic Exp $
//

#ifndef __DBXMLNSREINDEXER_HPP
#define __DBXMLNSREINDEXER_HPP

#include "../Indexer.hpp"

namespace DbXml {

class NsNodeRef;
class NsNode;
class Document;
class DbXmlNodeImpl;
class NsDomAttr;
class NsDomElement;
class DictionaryDatabase;
class EventReader;
	
class NsReindexer : public Indexer {
public:
	NsReindexer(Document &document,
		    OperationContext &oc,
		    int timezone,
		    bool forDelete);


	void indexAttributes(NsNodeRef &node);
	 // returns true if ancestor has value index
	bool indexElement(NsNodeRef &node);
	void lookupIndexes(NsNodeRef &node, bool &hasValueIndex,
			   bool &hasEdgePresenceIndex);

	void updateIndexes();
	bool willReindex() const;
	EventReader *getEventReader(NsNode *node);
	
protected:
	std::string makeUriName(int uriIndex, const char *lname);
	const char *lookupUri(int uriIndex);
	void indexAttribute(const char *aname, int auri,
			    NsNodeRef &parent, int index);
private:
	IndexSpecification is_;
	KeyStash stash_;
	Key key_;
	Key parentKey_;
	Document &document_;
	// this is redundant wrt Indexer, but dict_ in Indexer triggers
	// behavior that this class does not want
	DictionaryDatabase *dictionary_;
};

}
#endif
