//
// See the file LICENSE for redistribution information.
//
// Copyright (c) 2002,2008 Oracle.  All rights reserved.
//
// $Id: QueryPlanOptimizer.cpp,v 1.14 2008/01/08 21:54:24 bostic Exp $
//

#include "../DbXmlInternal.hpp"
#include "QueryPlanOptimizer.hpp"
#include "../query/QueryPlanToAST.hpp"

using namespace DbXml;
using namespace std;

ASTNode *QueryPlanOptimizer::optimize(ASTNode *item)
{
	return NodeVisitingOptimizer::optimize(item);
}

ASTNode *QueryPlanOptimizer::optimizeQueryPlanToAST(QueryPlanToAST *item)
{
	if(opt_.getPhase() == OptimizationContext::ALTERNATIVES) {
		item->setQueryPlan(optimizeQP(item->getQueryPlan()));
		item->setQueryPlan(item->getQueryPlan()->chooseAlternative(opt_, "QueryPlanToAST"));
	} else {
		item->setQueryPlan(item->getQueryPlan()->optimize(opt_));
	}
	return item;
}

