//
// See the file LICENSE for redistribution information.
//
// Copyright (c) 2002,2008 Oracle.  All rights reserved.
//
// $Id: QueryPlanToAST.hpp,v 1.5 2008/01/08 21:54:25 bostic Exp $
//

#ifndef __QUERYPLANTOAST_HPP
#define	__QUERYPLANTOAST_HPP

#include "../dataItem/DbXmlASTNode.hpp"

namespace DbXml
{

class QueryPlan;
class NodeIterator;

/**
 * Converts an ASTNode that returns nodes into a
 * QueryPlan object.
 */
class QueryPlanToAST : public DbXmlASTNode
{
public:
	QueryPlanToAST(QueryPlan *qp, StaticContext *context, XPath2MemoryManager *mm);

	QueryPlan *getQueryPlan() const { return qp_; }
	void setQueryPlan(QueryPlan *qp) { qp_ = qp; }

	virtual ASTNode *staticTyping(StaticContext *context);
	virtual DbXmlResult createResult(const DbXmlResult &contextItems, unsigned int props,
		DynamicContext *context) const;

private:
	QueryPlan *qp_;
};

class QueryPlanToASTResult : public ResultImpl
{
public:
	QueryPlanToASTResult(NodeIterator *it, const LocationInfo *location)
		: ResultImpl(location), it_(it) {}
	~QueryPlanToASTResult();

	Item::Ptr next(DynamicContext *context);
	std::string asString(DynamicContext *context, int indent) const { return ""; }

protected:
	NodeIterator *it_;
};

}

#endif
